]> git.donarmstrong.com Git - dsa-puppet.git/blob - modules/schroot/files/setup-all-dchroots
stretch does not debootstrap right now
[dsa-puppet.git] / modules / schroot / files / setup-all-dchroots
1 #!/bin/bash
2
3 ##
4 ## THIS FILE IS UNDER PUPPET CONTROL. DON'T EDIT IT HERE.
5 ## USE: git clone git+ssh://$USER@puppet.debian.org/srv/puppet.debian.org/git/dsa-puppet.git
6 ##
7
8 # Copyright (c) 2013 Peter Palfrader
9 #
10 # Permission is hereby granted, free of charge, to any person
11 # obtaining a copy of this software and associated documentation
12 # files (the "Software"), to deal in the Software without
13 # restriction, including without limitation the rights to use,
14 # copy, modify, merge, publish, distribute, sublicense, and/or sell
15 # copies of the Software, and to permit persons to whom the
16 # Software is furnished to do so, subject to the following
17 # conditions:
18 #
19 # The above copyright notice and this permission notice shall be
20 # included in all copies or substantial portions of the Software.
21 #
22 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
23 # EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
24 # OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
25 # NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
26 # HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
27 # WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
28 # FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
29 # OTHER DEALINGS IN THE SOFTWARE.
30
31 DPKGARCH=$(dpkg --print-architecture)
32 UNAMEARCH=$(uname -m)
33
34 if [ "${1:-}" = "buildd" ]; then
35     MODE=buildd
36     if ! [ -d /srv/buildd/ ]; then
37         echo >&2 "Error: /srv/buildd does not exist or is not a directory."
38         exit 1
39     fi
40 else
41     MODE=porterbox
42 fi
43
44 get_suites() {
45     case "$1" in
46       armhf|s390x)
47         echo "sid jessie wheezy"
48         ;;
49       ia64|s390)
50         echo "wheezy"
51         ;;
52       sparc)
53         echo "sid wheezy"
54         ;;
55       arm64|ppc64el)
56         echo "sid jessie"
57         ;;
58       amd64|i386)
59         echo "sid jessie wheezy squeeze"
60         ;;
61       *)
62         echo "sid jessie wheezy"
63         ;;
64     esac
65 }
66
67 archs="$DPKGARCH"
68 case "$DPKGARCH" in
69     amd64)
70         archs="$archs i386"
71         ;;
72     arm64)
73         archs="$archs armhf armel"
74         ;;
75     armhf)
76         if [ "$(uname -m)" = "aarch64" ] ; then
77             archs="$archs arm64"
78         fi
79         archs="$archs armel"
80         ;;
81     armel)
82         if [ "$(uname -m)" = "armv7l" ] && grep -w vfpv3 -q /proc/cpuinfo ; then
83             archs="$archs armhf"
84         fi
85         ;;
86     s390|s390x)
87         archs="s390 s390x"
88         ;;
89 esac
90
91 err=0
92
93 do_one() {
94     local a="$1"; shift
95     local s="$1"; shift
96
97     case "$MODE" in
98         buildd)
99             mkdir -p /srv/buildd/unpack
100             if ! chronic setup-dchroot -f -a "$a" -D -d '/srv/buildd/unpack' -K "$s"
101             then
102                 return 1
103             fi
104             ;;
105         porterbox)
106             if ! chronic setup-dchroot -f -a "$a" "$s"
107             then
108                 return 1
109             fi
110             ;;
111         *)
112             echo >&2 "Invalid mode $MODE"
113             exit 1
114     esac
115     return 0
116 }
117
118 for a in $archs; do
119     for s in `get_suites "$a"`; do
120         if ! do_one "$a" "$s"; then
121             err=1
122             echo >&2
123             echo >&2 "Error: setting up $s:$a dchroot failed."
124             echo >&2
125             echo >&2
126         fi
127     done
128 done
129
130 exit $err